/***************************************************************************
 *   Copyright (C) 2006 by Stefan Hirche   *
 *   hirche@astro.univie.ac.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "createform.h"
#include <klocale.h>
#include <qcheckbox.h>
#include <kurlrequester.h>
#include <klineedit.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qimage.h>
#include <qfile.h>
#include <qtextstream.h>

createForm::createForm(QWidget *parent, const char *name)
    :createDlg(parent, name)
{
}

/**
 * 
 */
void createForm::createButton_clicked()
{ 
  int widthIndex,heightIndex,black,white;
  int w,h,i,j,k,l=0;
  int row, col;
  QImage *image = new QImage();
  QImage *scaled;
  QRgb sum;
  int sumr, sumg, sumb;
  int index;
  if(!image->load(imageName->url()))
   {
    createButton->setEnabled(false);
    return;
   }
  if(width->value()==0)
   {
    width->setValue(10);
   }
  if(height->value()==0)
   {
    height->setValue(10);
   }
  qDebug("Start create");
  // scale image 
 *image = image->smoothScale(300,300,QImage::ScaleMin);
  widthIndex = image->width()/width->value();
  qDebug(QString("ImageWidth: %1 widthValue: %2 widthIndex %3").arg(image->width()).arg(width->value()).arg(widthIndex));
  if (ratio->isChecked())
   {
    height->setValue((int)( (float)(width->value())/(float)(image->width())*(float)(image->height())));
   }
  heightIndex = image->height()/height->value();
  qDebug(QString("ImageHeight: %1 heightValue: %2 heightIndex %3").arg(image->height()).arg(height->value()).arg(heightIndex));
    qDebug(QString("ImageWidth: %1 widthValue: %2 widthIndex %3").arg(image->width()).arg(width->value()).arg(widthIndex));
//Prepare image 

  scaled = new QImage();
  *scaled = image->copy();
// edge detect 
    
  for (i=0;i<image->width();i++)
   for (j=0;j<image->height();j++)
    {
    sumr = sumg = sumb = 0;
    index = 1;
    for (k=-9;k<=9;k++)
     for (l=-9;l<=9;l++)
      {
       col = i+k;
       row = j+l;
       if((row >= 0) && (row < image->height()) && (col >= 0) && (col < image->width()))
        {
         sum = scaled->pixel(col,row);
         sumr += qRed(sum);
         sumg += qGreen(sum);
         sumb += qBlue(sum);
         index++;
        }
      }
      sum = scaled->pixel(i,j);
      sumr = index*qRed(sum) - sumr;
      sumr = sumr>10?sumr:0;
      sumr = sumr<245?sumr:255;
      sumg = index*qGreen(sum) - sumg;
      sumg = sumg>10?sumg:0;
      sumg = sumg<245?sumg:255;
      sumb = index*qBlue(sum) - sumb;
      sumb = sumb>10?sumb:0;
      sumb = sumb<245?sumb:255;
      sum = qRgb(sumr, sumg, sumb);
      image->setPixel(i,j,sum);
     }
// grayscale image 
 *image = image->convertDepth(1);
//Image to Array
  QMemArray<int> array(width->value()*height->value());
  l = 0;
  for (w=0;w<width->value();w++)
   for (h=0;h<height->value();h++)
    { 
     black=white=0;
     for(i=w*widthIndex;i<(w+1)*widthIndex;i++)
      for(j=h*heightIndex;j<(h+1)*heightIndex;j++)
       {
        if(image->pixelIndex(i,j))
         black++;
        else
         white++;
       }
       if(white>black)
        {array[l]=0;}
       else
        {array[l]=1;}
       l++;
    }
  qDebug("End create");
  delete(image);
  delete(scaled);
  emit signalCreateAction(array,width->value(),height->value());
  close();
}

void createForm::createButton_check()
{
 if(imageName->url().isEmpty())
 createButton->setEnabled(false);
 else 
  createButton->setEnabled(true);
}
#include "createform.moc"
